﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.text.TextField;

	public class chemotax01 extends Sprite {
		var bac1:Array=new Array;
		var numbacs:int=100;
		var go:Boolean=false;
		var speed:Number=3;
		var i:int;

		public function chemotax01() {

			addEventListener(Event.ENTER_FRAME,animate);
			playBtn.addEventListener(MouseEvent.CLICK,handleClick);

			function animate(e:Event):void {  //chemotaxis movement
				if (go==true) {					
					for (i=0; i<numbacs; i++) {
						if (bac1[i].tumble==true) {
							bac1[i].spin();
							if (Math.random()>0.2) {
								bac1[i].tumble=false
							}
						} else {
							bac1[i].goForward(speed);
							if (Math.random()>bac1[i].tumbleprob(mouseX,mouseY)) {  //tumbles if going 180 degrees away from mouse, does not tumble if going toward
								bac1[i].tumble=true							
							}					
						}
					}
				}
			}

			function handleClick(pEvent:MouseEvent):void {  //set up the bacteria
				if (pEvent.target == playBtn) {
					for (i=0; i<numbacs; i++) {
						bac1[i]=new bacteria;
						bac1[i].graphics.lineStyle(2,0x0000ff);
						bac1[i].graphics.moveTo(-3,0);
						bac1[i].graphics.lineTo(3,0);
						bac1[i].x=Math.random()*400;
						bac1[i].y=Math.random()*400;
						bac1[i].rotation=Math.random()*360;
						bac1[i].tumble=false;
						bac1[i].forwardProb=0
						bac1[i].backwardProb=1
						addChild(bac1[i]);
					}
					go=true;
				}
			}

		}

	}
}